<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- properties.qdoc -->
  <title>Properties QML Type | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="prev" href="qml-qbslanguageitems-project.html" />
  <link rel="next" href="qml-qbslanguageitems-propertyoptions.html" />
<p class="naviNextPrevious headerNavi">
<a class="prevPage" href="qml-qbslanguageitems-project.html">Project</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="qml-qbslanguageitems-propertyoptions.html">PropertyOptions</a>
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#properties">Properties</a></li>
<li class="level1"><a href="#details">Detailed Description</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Properties QML Type</h1>
<span class="subtitle"></span>
<!-- $$$Properties-brief -->
<p>Provides conditional setting of properties. <a href="#details">More...</a></p>
<!-- @@@Properties -->
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> Import Statement:</td><td class="memItemRight bottomAlign"> import QbsLanguageItems .</td></tr></table></div><ul>
<li><a href="qml-qbslanguageitems-properties-members.html">List of all members, including inherited members</a></li>
</ul>
<a name="properties"></a>
<h2 id="properties">Properties</h2>
<ul>
<li class="fn"><b><b><a href="qml-qbslanguageitems-properties.html#condition-prop">condition</a></b></b> : bool</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-properties.html#overrideListProperties-prop">overrideListProperties</a></b></b> : bool</li>
</ul>
<!-- $$$Properties-description -->
<a name="details"></a>
<h2 id="details">Detailed Description</h2>
<p><b>Note: </b>This topic documents the Properties item in the context of <a href="qml-qbslanguageitems-product.html">products</a>. For more information about using it in sub-projects, see <a href="qml-qbslanguageitems-subproject.html">SubProject</a>.</p><p>The Properties item is an auxiliary item for setting multiple property values conditionally.</p>
<p>In the following example, two properties are set if the project is built for Windows:</p>
<pre class="cpp">

  Product {
      Properties {
          condition: qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;windows&quot;</span>)
          cpp<span class="operator">.</span>defines: <span class="operator">[</span><span class="string">&quot;ON_WINDOWS&quot;</span><span class="operator">]</span>
          cpp<span class="operator">.</span>includePaths: <span class="operator">[</span><span class="string">&quot;extraWindowsIncludes&quot;</span><span class="operator">]</span>
      }
  }

</pre>
<p>Multiple Properties items can be specified to set properties dependent on different conditions. The order of appearance is important. Semantics are similar to if-else-chains. The following example</p>
<pre class="cpp">

  Product {
      Properties {
          condition: qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;windows&quot;</span>)
          cpp<span class="operator">.</span>defines: <span class="operator">[</span><span class="string">&quot;ON_WINDOWS&quot;</span><span class="operator">]</span>
          cpp<span class="operator">.</span>includePaths: <span class="operator">[</span><span class="string">&quot;myWindowsIncludes&quot;</span><span class="operator">]</span>
      }
      Properties {
          condition: qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;linux&quot;</span>)
          cpp<span class="operator">.</span>defines: <span class="operator">[</span><span class="string">&quot;ON_LINUX&quot;</span><span class="operator">]</span>
          cpp<span class="operator">.</span>includePaths: <span class="operator">[</span><span class="string">&quot;myLinuxIncludes&quot;</span><span class="operator">]</span>
      }
      cpp<span class="operator">.</span>defines: <span class="operator">[</span><span class="string">&quot;ON_UNKNOWN_PLATFORM&quot;</span><span class="operator">]</span>
  }

</pre>
<p>is equivalent to</p>
<pre class="cpp">

  Product {
      cpp<span class="operator">.</span>defines: {
          <span class="keyword">if</span> (qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;windows&quot;</span>))
              <span class="keyword">return</span> <span class="operator">[</span><span class="string">&quot;ON_WINDOWS&quot;</span><span class="operator">]</span>;
          <span class="keyword">if</span> (qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;linux&quot;</span>))
              <span class="keyword">return</span> <span class="operator">[</span><span class="string">&quot;ON_LINUX&quot;</span><span class="operator">]</span>;
          <span class="keyword">return</span> <span class="operator">[</span><span class="string">&quot;ON_UNKNOWN_PLATFORM&quot;</span><span class="operator">]</span>;
      }
      cpp<span class="operator">.</span>includePaths: {
          <span class="keyword">if</span> (qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;windows&quot;</span>))
              <span class="keyword">return</span> <span class="operator">[</span><span class="string">&quot;myWindowsIncludes&quot;</span><span class="operator">]</span>;
          <span class="keyword">if</span> (qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;linux&quot;</span>))
              <span class="keyword">return</span> <span class="operator">[</span><span class="string">&quot;myLinuxIncludes&quot;</span><span class="operator">]</span>;
          <span class="keyword">return</span> base;
      }
  }

</pre>
<p>In Properties items, one can access the <a href="qml-qbslanguageitems-module.html#outer">outer value</a> of a property.</p>
<pre class="cpp">

  Product {
      Properties {
          condition: qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;windows&quot;</span>)
          cpp<span class="operator">.</span>defines: outer<span class="operator">.</span>concat(<span class="string">&quot;ON_WINDOWS&quot;</span>)     <span class="comment">// === [&quot;FOO&quot;, &quot;ON_WINDOWS&quot;]</span>
      }
      Properties {
          condition: qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;linux&quot;</span>)
          cpp<span class="operator">.</span>defines: <span class="operator">[</span><span class="string">&quot;ON_LINUX&quot;</span><span class="operator">]</span>                   <span class="comment">// === [&quot;ON_LINUX&quot;]</span>
      }
      cpp<span class="operator">.</span>defines: <span class="operator">[</span><span class="string">&quot;FOO&quot;</span><span class="operator">]</span>
  }

</pre>
<p>We suggest to use the Properties item for mutually exclusive conditions only. It is especially useful if there are several properties to set, based on the same condition.</p>
<!-- @@@Properties -->
<h2>Property Documentation</h2>
<!-- $$$condition -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="condition-prop">
<td class="tblQmlPropNode"><p>
<span class="name">condition</span> : <span class="type">bool</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The condition to be used for the other bindings in this item.</p>
<p>This is a mandatory property that has no default value.</p>
</div></div><!-- @@@condition -->
<br/>
<!-- $$$overrideListProperties -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="overrideListProperties-prop">
<td class="tblQmlPropNode"><p>
<span class="name">overrideListProperties</span> : <span class="type">bool</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>List properties set within this item will override the values coming from modules, rather than getting merged with them, which is the default behavior. Use this in the rare case that a module you depend on inserts a value into a list property that is problematic for some product.</p>
<p>Default: <code>false</code></p>
</div></div><!-- @@@overrideListProperties -->
<br/>
<p class="naviNextPrevious footerNavi">
<a class="prevPage" href="qml-qbslanguageitems-project.html">Project</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="qml-qbslanguageitems-propertyoptions.html">PropertyOptions</a>
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
